#ifndef DOCHOST_H_INC
#define DOCHOST_H_INC
#include <windows.h>
#include "webctrlint.h"
#include "site.h"

class DocHostUiHandlerClass : public IDocHostUIHandler
{
public:
   DocHostUiHandlerClass(WebCtrlClass *aWebCtrl) : WebCtrl(aWebCtrl)
   {}

   HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, LPVOID FAR* ppvObj)
   {
      if(WebCtrl->Site)
      {
         return WebCtrl->Site->QueryInterface(riid, ppvObj);
      }

      MessageBox(0, "ClientSite is null", "WebHost", MB_OK);
      return E_NOINTERFACE;
   }

   HRESULT STDMETHODCALLTYPE ShowContextMenu(DWORD                dwID,
                                             POINT     __RPC_FAR *ppt,
                                             IUnknown  __RPC_FAR *pcmdtReserved,
                                             IDispatch __RPC_FAR *pdispReserved)
   {
      return S_FALSE;
   }
   HRESULT STDMETHODCALLTYPE GetHostInfo(DOCHOSTUIINFO __RPC_FAR *pInfo)
   {
      pInfo->cbSize = sizeof(DOCHOSTUIINFO);

      pInfo->dwFlags = 0; // One or more of DOCHOSTUIFLAG_xxx

      // What happens if user double clicks?
      pInfo->dwDoubleClick = DOCHOSTUIDBLCLK_DEFAULT;

      return S_OK;
   }
   HRESULT STDMETHODCALLTYPE ShowUI(DWORD                              dwID,
                                    IOleInPlaceActiveObject __RPC_FAR *pActiveObject,
                                    IOleCommandTarget       __RPC_FAR *pCommandTarget,
                                    IOleInPlaceFrame        __RPC_FAR *pFrame,
                                    IOleInPlaceUIWindow     __RPC_FAR *pDoc)
   {
      return S_OK;
   }
   HRESULT STDMETHODCALLTYPE HideUI()
   {
      return S_OK;
   }
   HRESULT STDMETHODCALLTYPE UpdateUI()
   {
      return S_OK;
   }
   HRESULT STDMETHODCALLTYPE EnableModeless(BOOL fEnable)
   {
      return S_OK;
   }
   HRESULT STDMETHODCALLTYPE OnDocWindowActivate(BOOL fActivate)
   {
      return S_OK;
   }

   HRESULT STDMETHODCALLTYPE OnFrameWindowActivate(BOOL fActivate)
   {
      return S_OK;
   }

   HRESULT STDMETHODCALLTYPE ResizeBorder(LPCRECT prcBorder, IOleInPlaceUIWindow __RPC_FAR *pUIWindow, BOOL fRameWindow)
   {
      return S_OK;
   }

   HRESULT STDMETHODCALLTYPE TranslateAccelerator(LPMSG lpMsg, const GUID __RPC_FAR *pguidCmdGroup, DWORD nCmdID)
   {
      return S_OK;
   }


   HRESULT STDMETHODCALLTYPE GetOptionKeyPath(LPOLESTR __RPC_FAR *pchKey, DWORD dw)
   {
      return S_OK;
   }

   HRESULT STDMETHODCALLTYPE GetDropTarget(IDropTarget __RPC_FAR *pDropTarget, IDropTarget __RPC_FAR *__RPC_FAR *ppDropTarget)
   {
      return S_OK;
   }
   HRESULT STDMETHODCALLTYPE GetExternal(IDispatch __RPC_FAR *__RPC_FAR *ppDispatch)
   {
      *ppDispatch = 0;
      return S_OK;
   }

   HRESULT STDMETHODCALLTYPE TranslateUrl(DWORD dwTranslate, OLECHAR __RPC_FAR *pchURLIn, OLECHAR __RPC_FAR *__RPC_FAR *ppchURLOut)
   {
      return S_OK;
   }

   HRESULT STDMETHODCALLTYPE FilterDataObject(IDataObject __RPC_FAR *pDO, IDataObject __RPC_FAR *__RPC_FAR *ppDORet)
   {
      return S_OK;
   }
   ULONG STDMETHODCALLTYPE AddRef()
   {
      return 1;
   }

   ULONG STDMETHODCALLTYPE Release()
   {
      return 1;
   }

private:
   WebCtrlClass *WebCtrl;
};

#endif
