#ifndef EVENTS_H_INC
#define EVENTS_H_INC
#ifdef __GNUC__
#include "missing.h"
#else
#include <mshtmhst.h>
#endif

#include "webctrlint.h"
#include <exdispid.h>
#include <exdisp.h>

class WebBrowserEventClass : public DWebBrowserEvents2
{
public:
   WebBrowserEventClass(class WebCtrlClass *aWebCtrl) : WebCtrl(aWebCtrl)
   {
   }

   HRESULT STDMETHODCALLTYPE Invoke(DISPID             dispIdMember,
                                    REFIID             riid,
                                    LCID               lcid,
                                    WORD               wFlags,
                                    DISPPARAMS   FAR  *pDispParams,
                                    VARIANT      FAR  *pVarResult,
                                    EXCEPINFO    FAR  *pExcepInfo,
                                    unsigned int FAR  *puArgErr);

   HRESULT STDMETHODCALLTYPE GetTypeInfoCount(unsigned int *pctinfo)
   {
      MessageBox(0, "GetTypeInfoCount", "WebHost", MB_OK);
      *pctinfo = 0;
      return S_OK;
   }
   HRESULT STDMETHODCALLTYPE GetTypeInfo(unsigned int  iTInfo,
                                         LCID  lcid,
                                         ITypeInfo FAR* FAR*  ppTInfo)
   {
      return S_OK;
   }
   HRESULT STDMETHODCALLTYPE GetIDsOfNames(REFIID             riid,
                                           OLECHAR FAR* FAR*  rgszNames,
                                           unsigned int       cNames,
                                           LCID               lcid,
                                           DISPID       FAR*  rgDispId)
   {
      return S_OK;
   }
   HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void **ppvObject)
   {
      if (!memcmp((const void *)&riid, (const void *)&IID_IUnknown,          sizeof(GUID)) ||
          !memcmp((const void *)&riid, (const void *)&IID_IDispatch,         sizeof(GUID)) ||
          !memcmp((const void *)&riid, (const void *)&IID_IDocHostUIHandler, sizeof(GUID)))
      {
         *ppvObject = WebCtrl->DocHostUiHandler;
         return S_OK;
      }

      ppvObject = 0;
      return E_NOINTERFACE;
   }
   ULONG STDMETHODCALLTYPE AddRef()
   {
      return 1;
   }
   ULONG STDMETHODCALLTYPE Release()
   {
      return 1;
   }
   #ifdef __GNUC__
   void StatusTextChange(OLECHAR*) {}
   void ProgressChange(long int, long int) {}
   void CommandStateChange(long int, VARIANT_BOOL) {}
   void DownloadBegin() {}
   void DownloadComplete() {}
   void TitleChange(OLECHAR*) {}
   void PropertyChange(OLECHAR*) {}
   void BeforeNavigate2(IDispatch*, VARIANT*, VARIANT*, VARIANT*, VARIANT*, VARIANT*, VARIANT_BOOL*) {}
   void NewWindow2(IDispatch**, VARIANT_BOOL*) {}
   void NavigateComplete(IDispatch*, VARIANT*) {}
   void DocumentComplete(IDispatch*, VARIANT*) {}
   void OnQuit() {}
   void OnVisible(VARIANT_BOOL) {}
   void OnToolBar(VARIANT_BOOL) {}
   void OnMenuBar(VARIANT_BOOL) {}
   void OnStatusBar(VARIANT_BOOL) {}
   void OnFullScreen(VARIANT_BOOL) {}
   void OnTheaterMode(VARIANT_BOOL) {}
   void WindowSetResizable(VARIANT_BOOL) {}
   void WindowSetLeft(long int) {}
   void WindowSetTop(long int) {}
   void WindowSetWidth(long int) {}
   void WindowSetHeight(long int) {}
   void WindowClosing(VARIANT_BOOL, VARIANT_BOOL*) {}
   void ClientToHostWindow(long int*, long int*) {}
   void SetSecureLockIcon(long int) {}
   void FileDownload(VARIANT_BOOL*) {}
   #endif

private:
   WebCtrlClass *WebCtrl;
};
#endif
