#ifndef FRAME_H_INC
#define FRAME_H_INC

class OleFrameClass : public IOleInPlaceFrame
{
public:
   OleFrameClass(class WebCtrlClass *aWebCtrl) : WebCtrl(aWebCtrl)
   {}
   // IUnknown
   STDMETHODIMP QueryInterface(REFIID riid, void **ppvObject);
   STDMETHODIMP_(ULONG) AddRef(void);
   STDMETHODIMP_(ULONG) Release(void);
   // IOleWindow
    STDMETHODIMP GetWindow(HWND FAR *lphwnd);
    STDMETHODIMP ContextSensitiveHelp(BOOL fEnterMode);
   // IOleInPlaceUIWindow
   STDMETHODIMP GetBorder(LPRECT lprectBorder);
   STDMETHODIMP RequestBorderSpace(LPCBORDERWIDTHS pborderwidths);
   STDMETHODIMP SetBorderSpace(LPCBORDERWIDTHS pborderwidths);
   STDMETHODIMP SetActiveObject(IOleInPlaceActiveObject *pActiveObject, LPCOLESTR pszObjName);
   // IOleInPlaceFrame
   STDMETHODIMP InsertMenus(HMENU hmenuShared, LPOLEMENUGROUPWIDTHS lpMenuWidths);
   STDMETHODIMP SetMenu(HMENU hmenuShared, HOLEMENU holemenu, HWND hwndActiveObject);
   STDMETHODIMP RemoveMenus(HMENU hmenuShared);
   STDMETHODIMP SetStatusText(LPCOLESTR pszStatusText);
   STDMETHODIMP EnableModeless(BOOL fEnable);
   STDMETHODIMP TranslateAccelerator(LPMSG lpmsg, WORD wID);
   WebCtrlClass *WebCtrl;
};

#endif
