#include <windows.h>
#include "site.h"
#include "frame.h"
#include "webctrlint.h"
#ifdef __GNUC__
#include "missing.h"
#else
#include <mshtmhst.h>
#endif

const IID IID_IDocHostUIHandler ={0xbd3f23c0,0xd43e,0x11CF,{0x89, 0x3b, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x1a}};

STDMETHODIMP OleSiteClass::QueryInterface(REFIID riid, void **ppvObject)
{
   if(riid == IID_IUnknown || riid == IID_IOleClientSite)
   {
      *ppvObject = (IOleClientSite *)this;
   }
   else if(riid == IID_IOleInPlaceSite)
   {
      *ppvObject = (IOleInPlaceSite*)this;
   }
   else if(riid == IID_IDocHostUIHandler)
   {
      *ppvObject = Ctrl->DocHostUiHandler;
   }
   else if(riid == IID_IDispatch)
   {
      *ppvObject = Ctrl->WebBrowserEvent;
   }
   else
   {
      *ppvObject = 0;
      return E_NOINTERFACE;
   }
   return S_OK;
}

STDMETHODIMP_(ULONG) OleSiteClass::AddRef(void)
{
   return 1;
}

STDMETHODIMP_(ULONG) OleSiteClass::Release(void)
{
  return 1;
}

// IOleClientSite

STDMETHODIMP OleSiteClass::SaveObject()
{
   return S_OK;
}

STDMETHODIMP OleSiteClass::GetMoniker(DWORD dwAssign,DWORD dwWhichMoniker,IMoniker ** ppmk)
{
   return S_OK;
}

STDMETHODIMP OleSiteClass::GetContainer(LPOLECONTAINER FAR* ppContainer)
{
   // We are a simple object and don't support a container.
   *ppContainer = NULL;
   return E_NOINTERFACE;
}

STDMETHODIMP OleSiteClass::ShowObject()
{
 //  NOTIMPLEMENTED;
   // huh?
   return NOERROR;
}

STDMETHODIMP OleSiteClass::OnShowWindow(BOOL fShow)
{
   return S_OK;
}

STDMETHODIMP OleSiteClass::RequestNewObjectLayout()
{
   return S_OK;
}

// IOleWindow

STDMETHODIMP OleSiteClass::GetWindow(HWND FAR* lphwnd)
{
   *lphwnd = Ctrl->WebHost->GetHwnd();
   return S_OK;
}

STDMETHODIMP OleSiteClass::ContextSensitiveHelp(BOOL fEnterMode)
{
   return S_OK;
}

// IOleInPlaceSite


STDMETHODIMP OleSiteClass::CanInPlaceActivate()
{
   // Yes we can
   return S_OK;
}

STDMETHODIMP OleSiteClass::OnInPlaceActivate()
{
   // Why disagree.
   return S_OK;
}

STDMETHODIMP OleSiteClass::OnUIActivate()
{
   return S_OK;
}

STDMETHODIMP OleSiteClass::GetWindowContext(LPOLEINPLACEFRAME FAR* ppFrame,
                                           LPOLEINPLACEUIWINDOW FAR* ppDoc,
                                           LPRECT prcPosRect,
                                           LPRECT prcClipRect,
                                           LPOLEINPLACEFRAMEINFO lpFrameInfo)
{
   *ppFrame = Ctrl->Frame;
   *ppDoc = NULL;
   GetClientRect(Ctrl->WebHost->GetHwnd(), prcPosRect);
   GetClientRect(Ctrl->WebHost->GetHwnd(), prcClipRect);

   lpFrameInfo->fMDIApp = FALSE;
   lpFrameInfo->hwndFrame = Ctrl->WebHost->GetHwnd();
   lpFrameInfo->haccel = NULL;
   lpFrameInfo->cAccelEntries = 0;

   return S_OK;
}

STDMETHODIMP OleSiteClass::Scroll(SIZE scrollExtent)
{
   return S_OK;
}

STDMETHODIMP OleSiteClass::OnUIDeactivate(BOOL fUndoable)
{
   return S_OK;
}

STDMETHODIMP OleSiteClass::OnInPlaceDeactivate()
{
   return S_OK;
}

STDMETHODIMP OleSiteClass::DiscardUndoState()
{
   return S_OK;
}

STDMETHODIMP OleSiteClass::DeactivateAndUndo()
{
   return S_OK;
}

STDMETHODIMP OleSiteClass::OnPosRectChange(LPCRECT lprcPosRect)
{
   IOleInPlaceObject *inplace;
   if(!Ctrl->WebObject->QueryInterface(IID_IOleInPlaceObject, (void**)&inplace))
   {
      inplace->SetObjectRects(lprcPosRect, lprcPosRect);
   }
   return S_OK;
}
