#ifndef SITE_H_INC
#define SITE_H_INC

class WebHostWndClass;

class OleSiteClass : public IOleClientSite, public IOleInPlaceSite
{
public:
   OleSiteClass(class WebCtrlClass *aCtrl) : Ctrl(aCtrl)
   {}

   // IUnknown
   STDMETHODIMP QueryInterface(REFIID riid,void ** ppvObject);
   STDMETHODIMP_(ULONG) AddRef(void);
   STDMETHODIMP_(ULONG) Release(void);
   // IOleClientSite
   STDMETHODIMP SaveObject();
   STDMETHODIMP GetMoniker(DWORD dwAssign,DWORD dwWhichMoniker,IMoniker ** ppmk);
   STDMETHODIMP GetContainer(LPOLECONTAINER FAR* ppContainer);
   STDMETHODIMP ShowObject();
   STDMETHODIMP OnShowWindow(BOOL fShow);
   STDMETHODIMP RequestNewObjectLayout();
   // IOleWindow
    STDMETHODIMP GetWindow(HWND FAR* lphwnd);
    STDMETHODIMP ContextSensitiveHelp(BOOL fEnterMode);
    // IOleInPlaceSite methods
    STDMETHODIMP CanInPlaceActivate();
    STDMETHODIMP OnInPlaceActivate();
    STDMETHODIMP OnUIActivate();
    STDMETHODIMP GetWindowContext(LPOLEINPLACEFRAME FAR* lplpFrame,LPOLEINPLACEUIWINDOW FAR* lplpDoc,LPRECT lprcPosRect,LPRECT lprcClipRect,LPOLEINPLACEFRAMEINFO lpFrameInfo);
    STDMETHODIMP Scroll(SIZE scrollExtent);
    STDMETHODIMP OnUIDeactivate(BOOL fUndoable);
    STDMETHODIMP OnInPlaceDeactivate();
    STDMETHODIMP DiscardUndoState();
    STDMETHODIMP DeactivateAndUndo();
    STDMETHODIMP OnPosRectChange(LPCRECT lprcPosRect);
private:
    class WebCtrlClass *Ctrl;
};

#endif
