#ifndef STORAGE_H_INC
#define STORAGE_H_INC

#include <windows.h>

class NullStorageClass : public IStorage
{
public:
   // IUnknown
   STDMETHODIMP QueryInterface(REFIID riid,void ** ppvObject);
   STDMETHODIMP_(ULONG) AddRef(void);
   STDMETHODIMP_(ULONG) Release(void);
   // IStorage
   STDMETHODIMP CreateStream(const WCHAR * pwcsName,DWORD grfMode,DWORD reserved1,DWORD reserved2,IStream ** ppstm);
   STDMETHODIMP OpenStream(const WCHAR * pwcsName,void * reserved1,DWORD grfMode,DWORD reserved2,IStream ** ppstm);
   STDMETHODIMP CreateStorage(const WCHAR * pwcsName,DWORD grfMode,DWORD reserved1,DWORD reserved2,IStorage ** ppstg);
   STDMETHODIMP OpenStorage(const WCHAR * pwcsName,IStorage * pstgPriority,DWORD grfMode,SNB snbExclude,DWORD reserved,IStorage ** ppstg);
   STDMETHODIMP CopyTo(DWORD ciidExclude,IID const * rgiidExclude,SNB snbExclude,IStorage * pstgDest);
   STDMETHODIMP MoveElementTo(const OLECHAR * pwcsName,IStorage * pstgDest,const OLECHAR* pwcsNewName,DWORD grfFlags);
   STDMETHODIMP Commit(DWORD grfCommitFlags);
   STDMETHODIMP Revert(void);
   STDMETHODIMP EnumElements(DWORD reserved1,void * reserved2,DWORD reserved3,IEnumSTATSTG ** ppenum);
   STDMETHODIMP DestroyElement(const OLECHAR * pwcsName);
   STDMETHODIMP RenameElement(const WCHAR * pwcsOldName,const WCHAR * pwcsNewName);
   STDMETHODIMP SetElementTimes(const WCHAR * pwcsName,FILETIME const * pctime,FILETIME const * patime,FILETIME const * pmtime);
   STDMETHODIMP SetClass(REFCLSID clsid);
   STDMETHODIMP SetStateBits(DWORD grfStateBits,DWORD grfMask);
   STDMETHODIMP Stat(STATSTG * pstatstg,DWORD grfStatFlag);
};

#endif
