// This file defines the interface between the host application and the web browser control
#ifndef WEBCTRL_H_INC
#define WEBCTRL_H_INC
#include <windows.h>
#include <string>


// The host must create a class (typicaly the main window) that is derived from this class, and implements its methods
// The functions is called from the contols on certain events.
class WebHostInterface
{
public:
   virtual ~WebHostInterface() {}
   virtual void SetStatusText(LPCOLESTR pszStatusText) = 0;
   virtual void SetUrl(BSTR aStr) = 0;
   virtual HWND GetHwnd() = 0;
};

// This is the interface from the host to the control. The host creates the control by calling CreateWebCtrl
class WebCtrlInterface
{
public:
   virtual ~WebCtrlInterface() {}
   virtual long ShowUrl(const std::string &aUrl) = 0;
   virtual long ShowHtml(const std::string &aHtml) = 0;
   virtual void SetSize(int aWidth, int aHeight) = 0;
};

WebCtrlInterface *CreateWebCtrl(WebHostInterface *aWebHost, int aX, int aY, int aWidth, int aHeight);

#endif
