// This is a internal headerfile, the host application should not need to include it.
#ifndef WEBCTRLINTERNAL_H_INC
#define WEBCTRLINTERNAL_H_INC
#include "webctrl.h"

class WebCtrlClass : public WebCtrlInterface
{
public:
   WebCtrlClass(WebHostInterface *aWebHost, int aX, int aY, int aWidth, int aHeight);

   ~WebCtrlClass();
   long ShowUrl(const std::string &aUrl);
   long ShowHtml(const std::string &aHtml);
   void SetSize(int aWidth, int aHeight);

   void CreateEmbeddedWebControl(int aX, int aY, int aWidth, int aHeight);
   void UnCreateEmbeddedWebControl(void);
   void Connect();
   IOleObject *WebObject;
   class WebHostInterface *WebHost;
   class WebBrowserEventClass *WebBrowserEvent;
   class DocHostUiHandlerClass *DocHostUiHandler;
   class OleFrameClass *Frame;
   class NullStorageClass *Storage;
   class OleSiteClass *Site;
   unsigned long ConnectCookie;
};

#endif
