// This defines the main window class for the test application
#ifndef WEBHOST_H_INC
#define WEBHOST_H_INC
#include <windows.h>
#include <vector>
#include <string>
#include "webctrl.h"

class WebHostWndClass : public WebHostInterface
{
public:
   WebHostWndClass();
   ~WebHostWndClass();
   bool Create(HINSTANCE hAppInstance);
   HWND GetHwnd() { return hwnd; }
   void Go();
   HINSTANCE Instance;
   HWND hwnd;
   static LRESULT CALLBACK WndProcEntry(HWND aHwnd, UINT aMsg, WPARAM wParam, LPARAM lParam);
   LRESULT CALLBACK MainWndProc(HWND aHwnd, UINT aMsg, WPARAM wParam, LPARAM lParam);

   void SetUrl(BSTR aStr);
   void SetStatusText(LPCOLESTR aStatusText);
   WebCtrlInterface *WebCtrl;
   std::string HomeUrl;
private:
   enum ControlEnum
   {
      BackButton = 1040,
      HomeButton,
      UrlEdit,
      GoButton,
      StatusBarId
   };
   void OnWmCreate();
   LRESULT (CALLBACK *OldEditProc)(HWND, UINT, WPARAM, LPARAM);

   static LRESULT CALLBACK EditProc(HWND HwndEdit, UINT msg, WPARAM wParam, LPARAM lParam);

   HWND StatusBarWindow;
   std::vector<std::string> MruList;
};

inline std::string GetDlgItemString(HWND aHwnd, int aItemId)
{
   HWND HwndCtrl = GetDlgItem(aHwnd, aItemId);
   if(!HwndCtrl)
      return "";
   int Len = GetWindowTextLength(HwndCtrl) + 1;
   std::string Text;
   Text.resize(Len);
   GetWindowText(HwndCtrl, &Text[0], Len);
   return Text;
}

inline std::string WideCharToStdString(LPCOLESTR aString)
{
   int Size = WideCharToMultiByte(CP_ACP, 0, aString, -1, 0, 0, 0, 0);
   char *Text = new char [Size + 1];
   WideCharToMultiByte(CP_ACP, 0, aString, -1, Text, Size, 0, 0);
   std::string S(Text);
   delete [] Text;
   return S;
}

#endif
